package Script_Redo
{
	function serverCmdUndoBrick(%client)
	{
		if(!isObject(%client.redoStack))
		{
			%client.redoStack = new ScriptObject()
			{
				class = QueueSO;
				size = 512;
				head = 0;
				tail = 0;
			};
		}
		if(%client.undoStack.val[%client.undoStack.head - 1] !$= "")
		{
			%undoAction = %client.undoStack.val[%client.undoStack.head - 1];
			switch$(getField(%undoAction,1))
			{
				case "PLANT":
					if(isObject(getField(%undoAction,0)))
					{
						%redoAction = "\tPLANT";
						%brick = getField(%undoAction,0);
						%brick.oldName = %brick.getName();
						%brick.setName("redoTempBrick");
						%brick.isPlanted = 0;
						%brick.redoSettings = "N " @ %brick.oldName @ "\tLDB " @ nameToID(%brick.light.dataBlock) @ "\tEDB " @ nameToID(%brick.emitter.emitter) @ "\tEDIR " @ %brick.emitterDirection @ "\tIDB " @ nameToID(%brick.item.dataBlock) @ "\tIPOS " @ %brick.itemPosition @ "\tIDIR " @ %brick.itemDirection @ "\tIRT " @ %brick.itemRespawnTime / 1000 @ "\tRC " @ %brick.isRayCasting() @ "\tC " @ %brick.isColliding() @ "\tR " @ %brick.isRendering();	
						%brick.redoSettings["Sound"] = "N " @ %brick.oldName @ "\tSDB " @ nameToID(%brick.AudioEmitter.profile);
						%brick.redoSettings["VehicleSpawn"] = "N " @ %brick.oldName @ "\tVDB " @ nameToID(%brick.vehicle.dataBlock) @ "\tRCV " @ %brick.recolorVehicle @ "\tRC " @ %brick.isRayCasting() @ "\tC " @ %brick.isColliding() @ "\tR " @ %brick.isRendering();
						%brick.save("config/server/redoTempBrick.txt");
						%brick.isPlanted = 1;
						%file = new FileObject();
						%file.openForRead("config/server/redoTempBrick.txt");
						while(!%file.isEOF())
						{
							%line = %file.readLine();
							if(%line !$= "//--- OBJECT WRITE BEGIN ---" && %line !$= "//--- OBJECT WRITE END ---")
							{
								%redoAction = setField(%redoAction,0,getField(%redoAction,0) @ %line);
							}
						}
						%file.close();
						%file.delete();
					}
				case "COLOR":
					if(isObject(getField(%undoAction,0)))
					{
						%redoAction = getField(%undoAction,0) @ "\tCOLOR\t" @ getField(%undoAction,0).colorID;
					}
				case "COLORFX":
					if(isObject(getField(%undoAction,0)))
					{
						%redoAction = getField(%undoAction,0) @ "\tCOLORFX\t" @ getField(%undoAction,0).colorFXID;
					}
				case "SHAPEFX":
					if(isObject(getField(%undoAction,0)))
					{
						%redoAction = getField(%undoAction,0) @ "\tSHAPEFX\t" @ getField(%undoAction,0).shapeFXID;
					}
			}
			if(%redoAction !$= "")
			{
				%client.redoStack.push(%redoAction);
			}
		}
		Parent::serverCmdUndoBrick(%client);
	}
	function serverCmdRedoBrick(%client)
	{
		if(!isObject(%client.redoStack))
		{
			%client.redoStack = new ScriptObject()
			{
				class = QueueSO;
				size = 512;
				head = 0;
				tail = 0;
			};
		}
		if(%client.redoStack.val[%client.redoStack.head - 1] !$= "")
		{
			%redoAction = %client.redoStack.val[%client.redoStack.head - 1];
			switch$(getField(%redoAction,1))
			{
				case "PLANT":
					eval(getField(%redoAction,0));
					if(isObject(redoTempBrick))
					{
						%brick = nameToID("redoTempBrick");
						if(%brick.plant() != 0)
						{
							%brick.delete();
							return;
						}
						%brick.isPlanted = 1;
						%brick.setTrusted(1);
						%client.brickGroup.add(%brick);
						%client.wrenchBrick = %brick;
						if(%brick.redoSettings[%brick.getDatablock().specialBrickType] !$= "")
						{
							serverCmdSetWrenchData(%client,%brick.redoSettings[%brick.getDatablock().specialBrickType]);
							if(%brick.getDatablock().specialBrickType $= "VehicleSpawn")
							{
								%brick.respawnVehicle();
							}
						}
						else
						{
							serverCmdSetWrenchData(%client,%brick.redoSettings);
						}
						%client.wrenchBrick = "";
						%undoAction = %brick @ "\tPLANT";
					}
				case "COLOR":
					if(isObject(getField(%redoAction,0)))
					{
						%undoAction = getField(%redoAction,0) @ "\tCOLOR\t" @ getField(%redoAction,0).colorID;
						getField(%redoAction,0).setColor(getField(%redoAction,2));
					}
				case "COLORFX":
					if(isObject(getField(%redoAction,0)))
					{
						%undoAction = getField(%redoAction,0) @ "\tCOLORFX\t" @ getField(%redoAction,0).colorFXID;
						getField(%redoAction,0).setColorFX(getField(%redoAction,2));
					}
				case "SHAPEFX":
					if(isObject(getField(%redoAction,0)))
					{
						%undoAction = getField(%redoAction,0) @ "\tSHAPEFX\t" @ getField(%redoAction,0).shapeFXID;
						getField(%redoAction,0).setShapeFX(getField(%redoAction,2));
					}
			}
			if(%undoAction !$= "")
			{
				%client.undoStack.push(%undoAction);
				if(isObject(%client.player))
				{
					%client.player.playThread(0,"plant");
				}
			}
			%client.redoStack.pop();
		}
	}
};
activatePackage(Script_Redo);